Index: COPYING
===================================================================
--- COPYING	(revision 8006eed2788de714f5d76c85a5cb7d0c5891ef58)
+++ COPYING	(revision 994713afde7cd130d68e8417cfee8669e3d96182)
@@ -909,5 +286,4 @@
 
 	    How to Apply These Terms to Your New Programs
->>>>>>> FETCH_HEAD
 
   If you develop a new program, and you want it to be of the greatest
@@ -917,23 +293,13 @@
   To do so, attach the following notices to the program.  It is safest
 to attach them to the start of each source file to most effectively
-<<<<<<< HEAD
-state the exclusion of warranty; and each file should have at least
-=======
 convey the exclusion of warranty; and each file should have at least
->>>>>>> FETCH_HEAD
 the "copyright" line and a pointer to where the full notice is found.
 
-    <one line to give the program's name and a brief idea of what it does.>
-    Copyright (C) <year>  <name of author>
-
-<<<<<<< HEAD
-    This program is free software: you can redistribute it and/or modify
-    it under the terms of the GNU General Public License as published by
-    the Free Software Foundation, either version 3 of the License, or
-=======
+    MoleCuilder - to create and alter molecular systems
+    Copyright (C) 2010  Frederik Heber
+
     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the License, or
->>>>>>> FETCH_HEAD
     (at your option) any later version.
 
@@ -944,15 +310,4 @@
 
     You should have received a copy of the GNU General Public License
-<<<<<<< HEAD
-    along with this program.  If not, see <http://www.gnu.org/licenses/>.
-
-Also add information on how to contact you by electronic and paper mail.
-
-  If the program does terminal interaction, make it output a short
-notice like this when it starts in an interactive mode:
-
-    <program>  Copyright (C) <year>  <name of author>
-    This program comes with ABSOLUTELY NO WARRANTY; for details type `show w'.
-=======
     along with this program; if not, write to the Free Software
     Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
@@ -964,27 +319,12 @@
 when it starts in an interactive mode:
 
-    Gnomovision version 69, Copyright (C) year  name of author
-    Gnomovision comes with ABSOLUTELY NO WARRANTY; for details type `show w'.
->>>>>>> FETCH_HEAD
+    MoleCuilder version ??, Copyright (C) 2010  Frederik Heber
+    MoleCuilder comes with ABSOLUTELY NO WARRANTY; for details type 
+    `molecuilder --help-warranty'.
     This is free software, and you are welcome to redistribute it
-    under certain conditions; type `show c' for details.
+    under certain conditions; type `molecuilder --help-redistribute' 
+    for details.
 
 The hypothetical commands `show w' and `show c' should show the appropriate
-<<<<<<< HEAD
-parts of the General Public License.  Of course, your program's commands
-might be different; for a GUI interface, you would use an "about box".
-
-  You should also get your employer (if you work as a programmer) or school,
-if any, to sign a "copyright disclaimer" for the program, if necessary.
-For more information on this, and how to apply and follow the GNU GPL, see
-<http://www.gnu.org/licenses/>.
-
-  The GNU General Public License does not permit incorporating your program
-into proprietary programs.  If your program is a subroutine library, you
-may consider it more useful to permit linking proprietary applications with
-the library.  If this is what you want to do, use the GNU Lesser General
-Public License instead of this License.  But first, please read
-<http://www.gnu.org/philosophy/why-not-lgpl.html>.
-=======
 parts of the General Public License.  Of course, the commands you use may
 be called something other than `show w' and `show c'; they could even be
@@ -995,9 +335,8 @@
 necessary.  Here is a sample; alter the names:
 
-  Yoyodyne, Inc., hereby disclaims all copyright interest in the program
-  `Gnomovision' (which makes passes at compilers) written by James Hacker.
-
-  <signature of Ty Coon>, 1 April 1989
-  Ty Coon, President of Vice
+  University of Bonn, hereby disclaims all copyright interest in the program
+  `MoleCuilder' (which creates molecular systems) written by Frederik Heber.
+
+  Frederik Heber, 17 Aug 2010
 
 This General Public License does not permit incorporating your program into
@@ -1006,3 +345,2 @@
 library.  If this is what you want to do, use the GNU Library General
 Public License instead of this License.
->>>>>>> FETCH_HEAD
Index: README
===================================================================
--- README	(revision 8006eed2788de714f5d76c85a5cb7d0c5891ef58)
+++ README	(revision 994713afde7cd130d68e8417cfee8669e3d96182)
@@ -1,45 +1,27 @@
-<<<<<<< HEAD
-# Project: Molecuilder
+# Project: MoleCuilder
 #
 # heber@ins.uni-bonn.de
 
-	Molecuilder
+	MoleCuilder
 
-... is a tool that started as a mean to edit pcp configuration files (adding/remvoing groups of atoms, measuring bond lengths and so forth) and has grown into the many-body fragmentation test base of a new method coined BOSSANOVA (Bond Order diSSection in an ANOVA (ANalysis Of VAriance) -like fashion). It spills out configuration files for each fragment and includes joining and analyzing programs, to put together the partial energies and forces of each fragment to the total energy and forces. It allows for a complete Born-Oppenheimer molecular dynamics run.
-=======
-# Project: ParallelCarParrinello
-# Jan Hamaekers
-# Frederik Heber
-# 2005
-#
-# File: README
+... is a tool that started as a mean to edit pcp configuration files (adding/
+removing groups of atoms, measuring bond lengths and so forth), grew forth into 
+a many-body fragmentation test base of a new method coined BOSSANOVA (Bond
+Order diSSection in an ANOVA (ANalysis Of VAriance) - like fashion). It spilled 
+out configuration files for each fragment and included joining and analyzing 
+programs, to put together the partial energies and forces of each fragment to 
+the total energy and forces. Since then it has evolved into a complete toolbox
+for creating molecular systems and worlds.
 
-	Electronic Structure PACKage
-
-Is a collection of mathematical-physical programs to calculate via various ab-initio methods
-such as density functional theory or Hartree-Fock electronic(-magnetic) properties including
-the molecular (Car&Parrinello) dynamics of a many electron system. Especially, the linear
-response of the system to a external magnetic field in a perturbation approach in terms of 
-susceptibility and chemical shielding is implemented via the Density Functional Perturbation
-Theory. It was developed mainly by Jan Hamaekers (pcp) with additional code by Frederik Heber 
-(dfpt part in pcp) and also Ralf Wildenhuis (Gauss) at the Institute for Numerical Simulation 
-at the University of Bonn[1].
-
-
->>>>>>> FETCH_HEAD
 
 INSTALLATION NOTES
 ==================
 
-<<<<<<< HEAD
 The following packages are needed
 * GCC or alike
 * GSL (GNU Scientific Library, available at http://www.gnu.org/software/gsl)
 * Boost 1.4 or newer
-=======
-In general gcc or alike is needed to compile the sources, for more specific demands see the README files in the sub directory of each package part.
 
 LINKS
 =====
 [1] http://www.ins.uni-bonn.de/
->>>>>>> FETCH_HEAD
Index: bootstrap
===================================================================
--- bootstrap	(revision 994713afde7cd130d68e8417cfee8669e3d96182)
+++ bootstrap	(revision 994713afde7cd130d68e8417cfee8669e3d96182)
@@ -0,0 +1,14 @@
+#! /bin/sh
+# bootstrap git sources
+# This file is not distributed.
+
+set -x
+
+if git log > ChangeLog.t \
+   && diff ChangeLog.t ChangeLog >/dev/null 2>&1; then
+	mv -f ChangeLog.t ChangeLog
+else
+	rm -f ChangeLog.t
+fi
+
+autoreconf -v -i -I config -I m4
Index: configure.ac
===================================================================
--- configure.ac	(revision 8006eed2788de714f5d76c85a5cb7d0c5891ef58)
+++ configure.ac	(revision 994713afde7cd130d68e8417cfee8669e3d96182)
@@ -3,5 +3,5 @@
 
 AC_PREREQ(2.59)
-AC_INIT(Molecuilder, 1.0, heber@ins.uni-bonn.de, molecuilder)
+AC_INIT(MoleCuilder, 1.0.0, heber@ins.uni-bonn.de, molecuilder)
 AC_CONFIG_AUX_DIR(config)
 AC_CONFIG_SRCDIR([src/builder.cpp])
@@ -9,5 +9,5 @@
 AC_CONFIG_MACRO_DIR([m4])
 
-AM_INIT_AUTOMAKE(dist-bzip2 parallel-tests)
+AM_INIT_AUTOMAKE([dist-bzip2 1.11 parallel-tests color-tests])
 
 # Checks for programs.
@@ -15,6 +15,4 @@
 AC_PROG_CXX
 AC_PROG_CC
-# obselete by LT_INIT
-#AC_PROG_RANLIB
 AC_PROG_INSTALL
 AC_CHECK_PROG([LATEX],[latex],[latex],[:])
@@ -82,5 +80,5 @@
 fi
 
-# add replacement/saturation hydrogen or not 
+# use CppUnit TestRunner or not
 AC_ARG_ENABLE([ecut],AS_HELP_STRING([--enable-ecut],[Use ECut TestRunnerClient (default is no)]),
               [enable_ecut=$enableval], [enable_ecut=no])
@@ -88,4 +86,24 @@
   AC_DEFINE(HAVE_ECUT,1, ["Use ECut TestRunnerClient instead of our own."])
   AC_SUBST(HAVE_ECUT)
+fi
+
+# with valgrinding testsuite or not
+AC_ARG_WITH([valgrind],AS_HELP_STRING([--with-valgrind],[Use Valgrind on the testsuite (default is no)]),
+              [with_valgrind=$withval], [with_valgrind=no])
+if test x"$with_valgrind" = xyes; then
+  AC_CHECK_HEADER([valgrind/valgrind.h],
+    [
+      # check header
+      AC_DEFINE(HAVE_VALGRIND_TESTSUITE,1, ["Use Valgrind to check the testsuite."])
+      # check path
+      AC_PATH_PROG(VALGRIND, [valgrind], [/bin/false])
+      # set variables 
+      AC_SUBST(HAVE_VALGRIND_TESTSUITE)
+      AC_SUBST(VALGRIND)
+    ],
+    [
+      AC_MSG_ERROR(["Valgrind support requested but headers not available."])
+    ]
+  )
 fi
 
Index: src/Actions/Action.cpp
===================================================================
--- src/Actions/Action.cpp	(revision 8006eed2788de714f5d76c85a5cb7d0c5891ef58)
+++ src/Actions/Action.cpp	(revision 994713afde7cd130d68e8417cfee8669e3d96182)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * Action.cpp
@@ -5,4 +12,9 @@
  *      Author: crueger
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
Index: src/Actions/ActionHistory.cpp
===================================================================
--- src/Actions/ActionHistory.cpp	(revision 8006eed2788de714f5d76c85a5cb7d0c5891ef58)
+++ src/Actions/ActionHistory.cpp	(revision 994713afde7cd130d68e8417cfee8669e3d96182)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * ActionHistory.cpp
@@ -5,4 +12,9 @@
  *      Author: crueger
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
Index: src/Actions/ActionRegistry.cpp
===================================================================
--- src/Actions/ActionRegistry.cpp	(revision 8006eed2788de714f5d76c85a5cb7d0c5891ef58)
+++ src/Actions/ActionRegistry.cpp	(revision 994713afde7cd130d68e8417cfee8669e3d96182)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * Registry<Action>.cpp
@@ -5,4 +12,9 @@
  *      Author: crueger
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
Index: src/Actions/ActionSequence.cpp
===================================================================
--- src/Actions/ActionSequence.cpp	(revision 8006eed2788de714f5d76c85a5cb7d0c5891ef58)
+++ src/Actions/ActionSequence.cpp	(revision 994713afde7cd130d68e8417cfee8669e3d96182)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * ActionSequenze.cpp
@@ -5,4 +12,9 @@
  *      Author: crueger
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
Index: src/Actions/AnalysisAction/MolecularVolumeAction.cpp
===================================================================
--- src/Actions/AnalysisAction/MolecularVolumeAction.cpp	(revision 8006eed2788de714f5d76c85a5cb7d0c5891ef58)
+++ src/Actions/AnalysisAction/MolecularVolumeAction.cpp	(revision 994713afde7cd130d68e8417cfee8669e3d96182)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * MolecularVolumeAction.cpp
@@ -5,4 +12,9 @@
  *      Author: heber
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
Index: src/Actions/AnalysisAction/MolecularVolumeAction.hpp
===================================================================
--- src/Actions/AnalysisAction/MolecularVolumeAction.hpp	(revision 8006eed2788de714f5d76c85a5cb7d0c5891ef58)
+++ src/Actions/AnalysisAction/MolecularVolumeAction.hpp	(revision 994713afde7cd130d68e8417cfee8669e3d96182)
@@ -8,4 +8,9 @@
 #ifndef MOLECULARVOLUMEACTION_HPP_
 #define MOLECULARVOLUMEACTION_HPP_
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Actions/Action.hpp"
Index: src/Actions/AnalysisAction/PairCorrelationAction.cpp
===================================================================
--- src/Actions/AnalysisAction/PairCorrelationAction.cpp	(revision 8006eed2788de714f5d76c85a5cb7d0c5891ef58)
+++ src/Actions/AnalysisAction/PairCorrelationAction.cpp	(revision 994713afde7cd130d68e8417cfee8669e3d96182)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * PairCorrelationAction.cpp
@@ -5,4 +12,9 @@
  *      Author: heber
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
@@ -75,5 +87,5 @@
   ofstream output;
   ofstream binoutput;
-  std::vector< element *> elements;
+  std::vector<const element *> elements;
   string type;
   Vector Point;
Index: src/Actions/AnalysisAction/PairCorrelationAction.hpp
===================================================================
--- src/Actions/AnalysisAction/PairCorrelationAction.hpp	(revision 8006eed2788de714f5d76c85a5cb7d0c5891ef58)
+++ src/Actions/AnalysisAction/PairCorrelationAction.hpp	(revision 994713afde7cd130d68e8417cfee8669e3d96182)
@@ -8,4 +8,9 @@
 #ifndef PAIRCORRELATIONACTION_HPP_
 #define PAIRCORRELATIONACTION_HPP_
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Actions/Action.hpp"
Index: src/Actions/AnalysisAction/PointCorrelationAction.cpp
===================================================================
--- src/Actions/AnalysisAction/PointCorrelationAction.cpp	(revision 8006eed2788de714f5d76c85a5cb7d0c5891ef58)
+++ src/Actions/AnalysisAction/PointCorrelationAction.cpp	(revision 994713afde7cd130d68e8417cfee8669e3d96182)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * PointCorrelationAction.cpp
@@ -5,4 +12,9 @@
  *      Author: heber
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
@@ -21,4 +33,5 @@
 #include "World.hpp"
 
+#include <cmath>
 #include <iostream>
 #include <string>
@@ -76,5 +89,5 @@
   ofstream output;
   ofstream binoutput;
-  std::vector< element *> elements;
+  std::vector<const element *> elements;
   string type;
   Vector Point;
@@ -96,6 +109,6 @@
   cout << "Point to correlate to is  " << Point << endl;
   CorrelationToPointMap *correlationmap = NULL;
-  for(std::vector< element *>::iterator iter = elements.begin(); iter != elements.end(); ++iter)
-    cout << "element is " << (*iter)->symbol << endl;
+  for(std::vector<const element *>::iterator iter = elements.begin(); iter != elements.end(); ++iter)
+    cout << "element is " << (*iter)->getSymbol() << endl;
   std::vector<molecule*> molecules = World::getInstance().getSelectedMolecules();
   if (periodic)
Index: src/Actions/AnalysisAction/PointCorrelationAction.hpp
===================================================================
--- src/Actions/AnalysisAction/PointCorrelationAction.hpp	(revision 8006eed2788de714f5d76c85a5cb7d0c5891ef58)
+++ src/Actions/AnalysisAction/PointCorrelationAction.hpp	(revision 994713afde7cd130d68e8417cfee8669e3d96182)
@@ -8,4 +8,9 @@
 #ifndef POINTCORRELATIONACTION_HPP_
 #define POINTCORRELATIONACTION_HPP_
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Actions/Action.hpp"
Index: src/Actions/AnalysisAction/PrincipalAxisSystemAction.cpp
===================================================================
--- src/Actions/AnalysisAction/PrincipalAxisSystemAction.cpp	(revision 8006eed2788de714f5d76c85a5cb7d0c5891ef58)
+++ src/Actions/AnalysisAction/PrincipalAxisSystemAction.cpp	(revision 994713afde7cd130d68e8417cfee8669e3d96182)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * PrincipalAxisSystemAction.cpp
@@ -5,4 +12,9 @@
  *      Author: heber
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
@@ -64,5 +76,5 @@
       Vector x = (*iter)->getPosition();
       x -= *CenterOfGravity;
-      const double mass = (*iter)->getType()->mass;
+      const double mass = (*iter)->getType()->getMass();
       InertiaTensor.at(0,0) += mass*(x[1]*x[1] + x[2]*x[2]);
       InertiaTensor.at(0,1) += mass*(-x[0]*x[1]);
Index: src/Actions/AnalysisAction/SurfaceCorrelationAction.cpp
===================================================================
--- src/Actions/AnalysisAction/SurfaceCorrelationAction.cpp	(revision 8006eed2788de714f5d76c85a5cb7d0c5891ef58)
+++ src/Actions/AnalysisAction/SurfaceCorrelationAction.cpp	(revision 994713afde7cd130d68e8417cfee8669e3d96182)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * SurfaceCorrelationAction.cpp
@@ -5,4 +12,9 @@
  *      Author: heber
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
@@ -79,5 +91,5 @@
   ofstream output;
   ofstream binoutput;
-  std::vector< element *> elements;
+  std::vector<const element *> elements;
   string type;
   Vector Point;
@@ -112,4 +124,5 @@
   // find biggest molecule
   std::vector<molecule*> molecules = World::getInstance().getSelectedMolecules();
+  std::cout << "There are " << molecules.size() << " selected molecules." << std::endl;
   LCList = new LinkedCell(Boundary, LCWidth);
   FindNonConvexBorder(Boundary, TesselStruct, LCList, radius, NULL);
Index: src/Actions/AtomAction/AddAction.cpp
===================================================================
--- src/Actions/AtomAction/AddAction.cpp	(revision 8006eed2788de714f5d76c85a5cb7d0c5891ef58)
+++ src/Actions/AtomAction/AddAction.cpp	(revision 994713afde7cd130d68e8417cfee8669e3d96182)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * AddAction.cpp
@@ -6,8 +13,14 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
 #include "Actions/AtomAction/AddAction.hpp"
 #include "Actions/ActionRegistry.hpp"
+#include "Descriptors/AtomIdDescriptor.hpp"
 #include "atom.hpp"
 #include "element.hpp"
@@ -26,4 +39,18 @@
 #include "UIElements/Dialog.hpp"
 #include "Actions/ValueStorage.hpp"
+
+// memento to remember the state when undoing
+
+class AtomAddState : public ActionState {
+public:
+  AtomAddState(const Vector &_position, const element *_elemental, const atomId_t _id) :
+    position(_position),
+    elemental(_elemental),
+    id(_id)
+  {}
+  Vector position;
+  const element *elemental;
+  atomId_t id;
+};
 
 const char AtomAddAction::NAME[] = "add-atom";
@@ -52,5 +79,5 @@
 
 Action::state_ptr AtomAddAction::performCall() {
-  element * elemental = NULL;
+  const element * elemental = NULL;
   Vector position;
 
@@ -63,5 +90,5 @@
   first->setType(elemental);
   first->setPosition(position);
-  DoLog(1) && (Log() << Verbose(1) << "Adding new atom with element " << first->getType()->name << " at " << (first->getPosition()) << "." << endl);
+  DoLog(1) && (Log() << Verbose(1) << "Adding new atom with element " << first->getType()->getName() << " at " << (first->getPosition()) << "." << endl);
   // TODO: remove when all of World's atoms are stored.
   std::vector<molecule *> molecules = World::getInstance().getAllMolecules();
@@ -70,27 +97,41 @@
     (*iter)->AddAtom(first);
   }
-  return Action::success;
+  return Action::state_ptr(new AtomAddState(position, elemental, first->getId()));
 }
 
 Action::state_ptr AtomAddAction::performUndo(Action::state_ptr _state) {
-//  ParserLoadXyzState *state = assert_cast<ParserLoadXyzState*>(_state.get());
+  AtomAddState *state = assert_cast<AtomAddState*>(_state.get());
 
-  return Action::failure;
-//  string newName = state->mol->getName();
-//  state->mol->setName(state->lastName);
-//
-//  return Action::state_ptr(new ParserLoadXyzState(state->mol,newName));
+  DoLog(1) && (Log() << Verbose(1) << "Removing atom with id " << state->id << "." << endl);
+  World::getInstance().destroyAtom(state->id);
+
+  return Action::state_ptr(_state);
 }
 
 Action::state_ptr AtomAddAction::performRedo(Action::state_ptr _state){
-  return Action::failure;
+  AtomAddState *state = assert_cast<AtomAddState*>(_state.get());
+
+  atom * first = World::getInstance().createAtom();
+  first->setType(state->elemental);
+  first->setPosition(state->position);
+  DoLog(1) && (Log() << Verbose(1) << "Re-adding new atom with element " << state->elemental->getName() << " at " << state->position << "." << endl);
+  // TODO: remove when all of World's atoms are stored.
+  std::vector<molecule *> molecules = World::getInstance().getAllMolecules();
+  if (!molecules.empty()) {
+    std::vector<molecule *>::iterator iter = molecules.begin();
+    (*iter)->AddAtom(first);
+  }
+  if (first->getId() != state->id)
+    if (!first->changeId(state->id))
+      return Action::failure;
+  return Action::state_ptr(_state);
 }
 
 bool AtomAddAction::canUndo() {
-  return false;
+  return true;
 }
 
 bool AtomAddAction::shouldUndo() {
-  return false;
+  return true;
 }
 
Index: src/Actions/AtomAction/ChangeElementAction.cpp
===================================================================
--- src/Actions/AtomAction/ChangeElementAction.cpp	(revision 8006eed2788de714f5d76c85a5cb7d0c5891ef58)
+++ src/Actions/AtomAction/ChangeElementAction.cpp	(revision 994713afde7cd130d68e8417cfee8669e3d96182)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * ChangeElementAction.cpp
@@ -6,8 +13,14 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
 #include "Actions/AtomAction/ChangeElementAction.hpp"
 #include "Actions/ActionRegistry.hpp"
+#include "Descriptors/AtomIdDescriptor.hpp"
 #include "atom.hpp"
 #include "element.hpp"
@@ -19,4 +32,5 @@
 
 #include <iostream>
+#include <map>
 #include <string>
 
@@ -26,4 +40,18 @@
 #include "UIElements/Dialog.hpp"
 #include "Actions/ValueStorage.hpp"
+
+typedef std::map<int, const element *> ElementMap;
+
+// memento to remember the state when undoing
+
+class AtomChangeElementState : public ActionState {
+public:
+  AtomChangeElementState(ElementMap _Elements, const element *_elemental) :
+    Elements(_Elements),
+    elemental(_elemental)
+  {}
+  ElementMap Elements;
+  const element *elemental;
+};
 
 const char AtomChangeElementAction::NAME[] = "change-element";
@@ -51,12 +79,19 @@
 Action::state_ptr AtomChangeElementAction::performCall() {
   atom *first = NULL;
-  element *elemental = NULL;
+  const element *elemental;
   molecule *mol = NULL;
 
   ValueStorage::getInstance().queryCurrentValue(NAME, elemental);
 
+  // create undo state
+  ElementMap Elements;
+  for (World::AtomSelectionIterator iter = World::getInstance().beginAtomSelection(); iter != World::getInstance().endAtomSelection(); ++iter) {
+    Elements.insert(std::pair<int, const element *> (iter->second->getId(), iter->second->getType()));
+  }
+  AtomChangeElementState *UndoState = new AtomChangeElementState(Elements, elemental);
+
   for (World::AtomSelectionIterator iter = World::getInstance().beginAtomSelection(); iter != World::getInstance().endAtomSelection(); ++iter) {
     first = iter->second;
-    DoLog(1) && (Log() << Verbose(1) << "Changing atom " << *first << " to element " << elemental->symbol << "." << endl);
+    DoLog(1) && (Log() << Verbose(1) << "Changing atom " << *first << " to element " << *elemental << "." << endl);
     mol = first->getMolecule();
     first->removeFromMolecule(); // remove atom
@@ -64,27 +99,45 @@
     mol->AddAtom(first);  // add atom to ensure correctness of formula
   }
-  return Action::success;
+  return Action::state_ptr(UndoState);
 }
 
 Action::state_ptr AtomChangeElementAction::performUndo(Action::state_ptr _state) {
-//  ParserLoadXyzState *state = assert_cast<ParserLoadXyzState*>(_state.get());
+  AtomChangeElementState *state = assert_cast<AtomChangeElementState*>(_state.get());
+  atom *first = NULL;
+  molecule *mol = NULL;
 
-  return Action::failure;
-//  string newName = state->mol->getName();
-//  state->mol->setName(state->lastName);
-//
-//  return Action::state_ptr(new ParserLoadXyzState(state->mol,newName));
+  for(ElementMap::const_iterator iter = state->Elements.begin(); iter != state->Elements.end(); ++iter) {
+    first = World::getInstance().getAtom(AtomById(iter->first));
+    mol = first->getMolecule();
+    first->removeFromMolecule(); // remove atom
+    first->setType(iter->second);
+    mol->AddAtom(first);  // add atom to ensure correctness of formula
+  }
+
+  return Action::state_ptr(_state);
 }
 
 Action::state_ptr AtomChangeElementAction::performRedo(Action::state_ptr _state){
-  return Action::failure;
+  AtomChangeElementState *state = assert_cast<AtomChangeElementState*>(_state.get());
+  atom *first = NULL;
+  molecule *mol = NULL;
+
+  for(ElementMap::const_iterator iter = state->Elements.begin(); iter != state->Elements.end(); ++iter) {
+    first = World::getInstance().getAtom(AtomById(iter->first));
+    mol = first->getMolecule();
+    first->removeFromMolecule(); // remove atom
+    first->setType(state->elemental);
+    mol->AddAtom(first);  // add atom to ensure correctness of formula
+  }
+
+  return Action::state_ptr(_state);
 }
 
 bool AtomChangeElementAction::canUndo() {
-  return false;
+  return true;
 }
 
 bool AtomChangeElementAction::shouldUndo() {
-  return false;
+  return true;
 }
 
